#ifndef PSTADE_LIBS_OVEN_TEST_DETAIL_NEW_LIST_HPP
#define PSTADE_LIBS_OVEN_TEST_DETAIL_NEW_LIST_HPP


// PStade.Oven
//
// Copyright Shunsuke Sogame 2005-2007.
// Distributed under the Boost Software License)( Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)


#include <pstade/oven/detail/prefix.hpp>
#include <algorithm> // for_each
#include <memory> // auto_ptr
#include <boost/mpl/assert.hpp>
#include <boost/ptr_container/ptr_list.hpp>
#include <boost/range/begin.hpp>
#include <boost/range/end.hpp>
#include <boost/type_traits/is_const.hpp>
#include "./push_back_new.hpp"


namespace pstade { namespace oven { namespace test {


template< class Clonable >
std::auto_ptr< boost::ptr_list<Clonable> >
new_list0()
{
    BOOST_MPL_ASSERT_NOT((boost::is_const<Clonable>));
    boost::ptr_list<Clonable> pc;
    return pc.clone();
}


template< class Clonable, class Range >
std::auto_ptr< boost::ptr_list<Clonable> >
new_list(Range const& rng)
{
    BOOST_MPL_ASSERT_NOT((boost::is_const<Clonable>));
    boost::ptr_list<Clonable> pc;
    std::for_each(boost::begin(rng), boost::end(rng), test::push_back_new<Clonable>(pc));
    return pc.clone();
}


} } } // namespace pstade::oven::test


#endif
